package Workflow::App::Approver;

use strict;
use warnings;

use Encode;
use MT::Approver;

use Exporter;
@Workflow::App::Approver::ISA = qw( Exporter );
use vars qw( @EXPORT_OK );
@EXPORT_OK = qw( get_max_order );

my $char = '123';

sub edit_approver {
    my $app = shift;
    my %param;
    my $q = $app->param;
    my $id = $q->param('id');

    return $app->return_to_dashboard( redirect => 1 ) if !$q->param('blog_id');

    my $plugin = MT->component('Workflow');

    if (!$id) {
        $param{ new_object } = 1;
        $param{ page_title } = $plugin->translate('New Approver');
    } else {
        my $approver = MT::Approver->load({ id => $id, blog_id => $q->param('blog_id') });
        $param{ id } = $q->param('id');
        $param{ blog_id } =  $q->param('blog_id');
        $param{ name } = $approver->name;
        $param{ description } = $approver->description;

        my @authors;
        for my $p ( split ',', $approver->author ) {
            $p =~ s/'$char(.+)$char'/$1/;
            push @authors, $p;
        }
        $param{ author } = join( "\n", @authors );

        $param{ order } = $approver->order;
        $param{ approve_email_order } = $approver->approve_email_order;
        $param{ no_approve_email_order } = $approver->no_approve_email_order;
        $param{ send_approve_mail } = $approver->send_approve_mail;
        $param{ page_title } = $plugin->translate('Update Approver');
    }

    $param{ saved } = $q->param('saved');
    my $tmpl = 'edit_approver.tmpl';
    return $app->build_page($tmpl, \%param);
}

sub post_save {
    my ($eh, $app, $obj, $orig_obj) = @_;

    my $q = $app->param;
    my $authors = $q->param('author');

    my @authors = split(/\n/, $authors);
    my $author = "'$char" . join( "$char','$char", @authors ) . "$char'";
    $author =~ s/(?![\n])[[:cntrl:]]//g;

    $obj->author($author);
    $obj->save;
}

sub get_max_order {
    my $app = shift;
    my $q = $app->param;

    my ( $terms, $args );
    $args->{ sort } = 'order';
    $args->{ direction } = 'descend';
    $terms->{ blog_id } = $q->param('blog_id');
    my $approver = MT::Approver->load( $terms, $args );

    return $approver->order if $approver || 0;
}

1;
