package Workflow::CMS::Author;

use strict;
use warnings;

use MT::Approver;
use Data::Dumper;

sub set_author_param {
    my ($cb, $app, $param, $tmpl) = @_;

    my $q = $app->param;
    my @approver = MT::Approver->load();

    my $fields;
    for my $approve ( @approver ) {
        $fields->{ $approve->order } = $approve->name;
    }
    $param->{approve_loop} = $fields;
}

sub edit_author {
    my ($cb, $app, $template) = @_;

    my $old;
    my $new;

    $old = <<HTML;
  </fieldset>

  <h2><__trans phrase="System Permissions"></h2>
HTML
    $old = quotemeta($old);

    my $plugin = MT->component('Workflow');
    my $message1 = $plugin->translate("Approve Order");
    my $message2 = $plugin->translate("No Approver");

    $new = <<HTML;
    <mtapp:setting
       id="approve_order"
       label="$message1">
      <select name="approve_order" id="approve_order">
        <option value="0">$message2</option>
<mt:loop name="approve_loop">
        <option value="<mt:var name="__key__">"><mt:var name="__value__"></option>
</mt:loop>
      </select>
    </mtapp:setting>

  </fieldset>

  <h2><__trans phrase="System Permissions"></h2>
HTML

    $$template =~ s/$old/$new/;
}

1;
